diff --git a/books/Makefile.pamphlet b/books/Makefile.pamphlet
index e0d48d2..6836403 100644
--- a/books/Makefile.pamphlet
+++ b/books/Makefile.pamphlet
@@ -161,18 +161,23 @@ ${PDF}/toc.pdf: ${BOOKS}
 	echo "\\newpage" >>toc.toc ; \
 	echo "\\section*{Volume 10: Axiom Algebra: Implementation}" >>toc.toc ; \
 <<sed pattern>>
+            <bookvol10.toc >>toc.toc ; \
 	echo "\\newpage" >>toc.toc ; \
 	echo "\\section*{Volume 10.1: Axiom Algebra: Theory}" >>toc.toc ; \
 <<sed pattern>>
+            <bookvol10.1.toc >>toc.toc ; \
 	echo "\\newpage" >>toc.toc ; \
 	echo "\\section*{Volume 10.2: Axiom Algebra: Categories}" >>toc.toc ; \
 <<sed pattern>>
+            <bookvol10.2.toc >>toc.toc ; \
 	echo "\\newpage" >>toc.toc ; \
 	echo "\\section*{Volume 10.3: Axiom Algebra: Domains}" >>toc.toc ; \
 <<sed pattern>>
+            <bookvol10.3.toc >>toc.toc ; \
 	echo "\\newpage" >>toc.toc ; \
 	echo "\\section*{Volume 10.4: Axiom Algebra: Packages}" >>toc.toc ; \
 <<sed pattern>>
+            <bookvol10.4.toc >>toc.toc ; \
             <bookvol10.toc >>toc.toc ; \
 	echo "\\newpage" >>toc.toc ; \
 	echo "\\section*{Volume 11: Axiom Browser}" >>toc.toc ; \
diff --git a/src/input/Makefile.pamphlet b/src/input/Makefile.pamphlet
index 071d86e..f8620d9 100644
--- a/src/input/Makefile.pamphlet
+++ b/src/input/Makefile.pamphlet
@@ -72,7 +72,8 @@ ${MID}/%.as: ${IN}/%.as.pamphlet
 	  ${TANGLE} ${IN}/$*.as.pamphlet >$*.as)
 
 ${DOC}/%.input.dvi: ${IN}/%.input.pamphlet 
-	@ echo generic 14 making ${DOC}/$*.input.dvi from ${IN}/$*.input.pamphlet
+	@ echo generic 14 making ${DOC}/$*.input.dvi from \
+               ${IN}/$*.input.pamphlet
 	@ (cd ${DOC} ; \
 	cp ${IN}/$*.input.pamphlet ${DOC} ; \
 	${DOCUMENT} ${NOISE} $*.input ; \
@@ -377,13 +378,14 @@ REGRES= algaggr.regress algbrbf.regress  algfacob.regress alist.regress  \
 
 IN=     ${SRC}/input
 MID=	${INT}/input
+TMPFN:=$(shell echo $$RANDOM)
 
 all: ${OUTS} ${REGRES} 
 	@ echo 0 starting algebra regression testing
 	@ (cd ${MID} ; \
 	  ${TANGLE} -t8 -R"algebra.regress" ${SRC}/algebra/Makefile.pamphlet \
             >Makefile.algebra ; \
-          make -f Makefile.algebra )
+          ${MAKE} -f Makefile.algebra )
 	@ echo 1 finished ${INT}/input
  
 %.input: ${IN}/%.input.pamphlet
@@ -398,19 +400,19 @@ in the standard Axiom banner. These cause mismatches in otherwise
 identical output.
 <<regression tests>>=
 %.output: %.input
-	@ echo running test file $* 
-	@ echo ')set message test on' > tmp.input 
-	@ echo ')set message auto off' >> tmp.input 
-	@ echo ')read $*' >> tmp.input 
-	@ echo ')lisp (bye)' >> tmp.input 
+	@ echo running test file $* using $*${TMPFN}.input 
+	@ echo ')set message test on' > $*${TMPFN}.input 
+	@ echo ')set message auto off' >> $*${TMPFN}.input 
+	@ echo ')read $*' >> $*${TMPFN}.input 
+	@ echo ')lisp (bye)' >> $*${TMPFN}.input 
 	@ if [ -z "${NOISE}" ] ; then \
-	   echo ")read tmp.input" | ${TESTSYS} \
+	   echo ")read $*${TMPFN}.input" | ${TESTSYS} \
                 | egrep -v '(Timestamp|Version)' | tee $*.output ; \
 	  else \
-	   echo ")read tmp.input" | ${TESTSYS} \
+	   echo ")read $*${TMPFN}.input" | ${TESTSYS} \
                 | egrep -v '(Timestamp|Version)' > $*.output ; \
 	  fi 
-	@ rm tmp.input 
+	@ rm $*${TMPFN}.input 
 
 @
 A regression test file will run the input file. Each input file
@@ -434,7 +436,6 @@ the built-in gclweb function (see src/interp/gclweb.lisp)
 	  else \
            echo ')read $*.input' | ${TESTSYS} >${TMP}/trace ; \
 	  fi ; \
-	  rm $*.input ; \
 	  if [ -z "${NOISE}" ] ; then \
            echo ')lisp (regress "$*.output")' | ${TESTSYS} \
                 | egrep -v '(Timestamp|Version)' | tee $*.regress ; \
